/* Read and write the current averages of all the data */

#include "comext.h"
#include <stdio.h>
#include <math.h>

printaves(fp)
FILE *fp;
{
   int i,j,m;

   /* Number of sweeps so far */
   cfwrite(&cntenergy,sizeof(int),1,fp);
   cfwrite(&binsz,sizeof(int),1,fp);

   /* Energy values */
   cfwrite(avenergy,sizeof(double),M,fp); 
   cfwrite(avenersq,sizeof(double),M,fp); 
   cfwrite(avspheat,sizeof(double),M,fp); 
   cfwrite(avspheatsq,sizeof(double),M,fp); 
   cfwrite(avbinenersq,sizeof(double),M,fp); 
   cfwrite(minenergy,sizeof(float),M,fp); 
   cfwrite(maxenergy,sizeof(float),M,fp); 

   /* Mag values */
   cfwrite(avspin,sizeof(double),M,fp); 
   cfwrite(avspinsq,sizeof(double),M,fp); 
   cfwrite(avsuss,sizeof(double),M,fp); 
   cfwrite(avsusssq,sizeof(double),M,fp); 
   cfwrite(avbinspinsq,sizeof(double),M,fp); 
   cfwrite(minspin,sizeof(float),M,fp); 
   cfwrite(maxspin,sizeof(float),M,fp); 

   /* Magsq values */
   cfwrite(avmagsq,sizeof(double),M,fp); 
   cfwrite(avimsuss,sizeof(double),M,fp); 
   cfwrite(avimsusssq,sizeof(double),M,fp); 
   cfwrite(avbinmagsqsq,sizeof(double),M,fp); 

   /* Energy autocorrs */
   for (m=0;m<M;m++)
      for (i=0;i<NA;i++) 
	 cfwrite(&EA[m][i],sizeof(double),1,fp);
   for (m=0;m<M;m++)
      for (i=0;i<NA;i++) 
	 cfwrite(&lastNEA[m][i],sizeof(double),1,fp);

   /* Mag autocorrs */
   for (m=0;m<M;m++)
      for (i=0;i<NA;i++) 
	 cfwrite(&MA[m][i],sizeof(double),1,fp);
   for (m=0;m<M;m++)
      for (i=0;i<NA;i++) 
	 cfwrite(&lastNMA[m][i],sizeof(double),1,fp);

   /* Magsq autocorrs */
   for (m=0;m<M;m++)
      for (i=0;i<NA;i++) 
	 cfwrite(&M2A[m][i],sizeof(double),1,fp);
   for (m=0;m<M;m++)
      for (i=0;i<NA;i++) 
	 cfwrite(&lastNM2A[m][i],sizeof(double),1,fp);
    
   cfwrite(&sites,sizeof(int),1,fp);
   /* Histogram of cluster sizes */
   cfwrite(ns,sizeof(int),sites,fp);

}


readaves(fp)
FILE *fp;
{
   int i,j,m;

   /* Number of sweeps so far */
   fread(&oldcount,sizeof(int),1,fp);
   fread(&binsz,sizeof(int),1,fp);
   cntenergy = oldcount;
   cntspin = oldcount;

   /* Energy values */
   fread(avenergy,sizeof(double),M,fp); 
   fread(avenersq,sizeof(double),M,fp); 
   fread(avspheat,sizeof(double),M,fp); 
   fread(avspheatsq,sizeof(double),M,fp); 
   fread(avbinenersq,sizeof(double),M,fp); 
   fread(minenergy,sizeof(float),M,fp); 
   fread(maxenergy,sizeof(float),M,fp); 

   /* Mag values */
   fread(avspin,sizeof(double),M,fp); 
   fread(avspinsq,sizeof(double),M,fp); 
   fread(avsuss,sizeof(double),M,fp); 
   fread(avsusssq,sizeof(double),M,fp); 
   fread(avbinspinsq,sizeof(double),M,fp); 
   fread(minspin,sizeof(float),M,fp); 
   fread(maxspin,sizeof(float),M,fp); 

   /* Magsq values */
   fread(avmagsq,sizeof(double),M,fp); 
   fread(avimsuss,sizeof(double),M,fp); 
   fread(avimsusssq,sizeof(double),M,fp); 
   fread(avbinmagsqsq,sizeof(double),M,fp); 

   /* Energy autocorrs */
   for (m=0;m<M;m++)
      for (i=0;i<NA;i++) 
	 fread(&EA[m][i],sizeof(double),1,fp);
   for (m=0;m<M;m++)
      for (i=0;i<NA;i++) 
	 fread(&lastNEA[m][i],sizeof(double),1,fp);

   /* Mag autocorrs */
   for (m=0;m<M;m++)
      for (i=0;i<NA;i++) 
	 fread(&MA[m][i],sizeof(double),1,fp);
   for (m=0;m<M;m++)
      for (i=0;i<NA;i++) 
	 fread(&lastNMA[m][i],sizeof(double),1,fp);

   /* Magsq autocorrs */
   for (m=0;m<M;m++)
      for (i=0;i<NA;i++) 
	 fread(&M2A[m][i],sizeof(double),1,fp);
   for (m=0;m<M;m++)
      for (i=0;i<NA;i++) 
	 fread(&lastNM2A[m][i],sizeof(double),1,fp);
    
   fread(&sites,sizeof(int),1,fp);
   /* Histogram of cluster sizes */
   fread(ns,sizeof(int),sites,fp);

}

